#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
using namespace std;

int main() {
	int n;
	cin >> n;

	vector<long long> a(n);
	vector<int> r(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> r[i];
	}

	// illumination ranges of lamps
	vector<pair<int, int>> left(n), right(n);
	for (int i = 0; i < n; ++i) {
		left[i] = {i - r[i], i};
		right[i] = {i + r[i], i};
	}
	sort(begin(left), end(left));
	sort(begin(right), end(right));

	vector<long long> power(n); // required power levels of lamps
	int lefti = 0, righti = 0; // sliding window
	int besti = -1;
	long long intensity = 0; // current light intensity

	// loop over pots
	for (int i = 0; i < n; ++i) {
		// check ranges that have already started
		while (lefti < n and left[lefti].first <= i) {
			int lampi = left[lefti].second;
			if (besti == -1 or besti + r[besti] < lampi + r[lampi]) {
				// this is the best so far
				besti = lampi;
			}
			++lefti;
		}

		a[i] -= intensity; // required additional intensity
		if (a[i] > 0) {
			// get it from the best lamp
			power[besti] += a[i];
			intensity += a[i];
		}

		// ranges that are ending
		while (righti < n and right[righti].first <= i) {
			int lampi = right[righti].second;
			intensity -= power[lampi];
			righti++;
		}
	}

	// answer
	long long sum = 0;
	for (int i = 0; i < n; ++i) {
		sum += power[i];
	}
	cout << sum << "\n";
}
