#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
using namespace std;

#define done(r, m) (cout << r << '\n', cerr << m << '\n', exit(0))

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	ifstream in(argv[1]);
	//ifstream hint(argv[2]);
	ifstream out(argv[3]);

	int n, m;
	in >> n >> m;
	vector<int> lit(n);
	for (auto & x : lit) {
		in >> x;
	}
	map<int, set<int>> graph;
	for (int i = 0; i < m; ++i) {
		int u, v;
		in >> u >> v;
		graph[u].insert(v);
		graph[v].insert(u);
	}

	int k;
	out >> k;
	if (!out or 1 > k or k > 5e5) done(0, "Wrong answer");
	int prev, next;
	for (int i = 0; i < k; ++i) {
		out >> next;
		if (!out or 1 > next or next > n) done(0, "Wrong answer");
		if (i == 0 and next != 1) done(0, "Wrong answer");
		if (i > 0 and not graph[prev].contains(next)) done(0, "Wrong answer");
		lit[next - 1] = 1 - lit[next - 1];
		prev = next;
	}
	char c;
	if (out >> c) done(0, "Wrong answer");

	for (auto x : lit) {
		if (x != 1) done(0, "Wrong answer");
	}
	done(1, "OK");
}
