#!/usr/bin/env python3

# Input validator

import sys

st = {2, 3, 4, 5, 6}

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m = (int(x) for x in fi.readline().split())
if 2 > n or n > 1e5:
    sys.exit('N out of range')
if 1 > m or m > 1e5:
    sys.exit('M out of range')
print(n, m, file=fo)

t = [int(x) for x in fi.readline().split()]
if len(t) != n:
    sys.exit('Invalid length of T')
if min(t) < 0 or max(t) > 1:
    sys.exit('Invalid values in T')
if t.count(0) == 0:
    sys.exit('No zeros in T')
print(*t, file=fo)

s = set()
for i in range(m):
    u, v = (int(x) for x in fi.readline().split())
    if 1 > u or u >= v:
        sys.exit(f'U[{1 + i}] out of range')
    if u >= v or v > n:
        sys.exit(f'V[{1 + i}] out of range')
    if (u, v) in s:
        sys.exit(f'Duplicate corridor {u}-{v}')
    s.add((u, v))
    print(u, v, file=fo)

if n > 100:
    st.discard(2)
if t.count(0) != 1:
    st.discard(3)
if s != set((i, i + 1) for i in range(1, n)):
    st.discard(4)
if s != set((1, i + 1) for i in range(1, n)):
    st.discard(5)

fi.close()
fo.close()

if len(sys.argv) > 4 and sys.argv[4] == '-v':
    print('subtasks:', *st)
