#include <iostream>
#include <vector>
using namespace std;

// input

int n, m;
vector<int> lit; // is room currently lit?
vector<vector<int>> adj; // list of adjacent rooms

// dfs traversal tree

vector<bool> visited;
vector<int> parent;
vector<vector<int>> children;

void dfs1(int curr, int prev) {
	visited[curr] = true;
	for (int next : adj[curr]) {
		if (next == prev) continue;
		if (visited[next]) continue;
		parent[next] = curr;
		children[curr].push_back(next);
		dfs1(next, curr);
	}
}

// answer

vector<int> answer;

void move(int curr) {
	answer.push_back(curr);
	lit[curr] = 1 - lit[curr];
}

void dfs2(int curr) {
	move(curr);

	for (int next : children[curr]) {
		dfs2(next);
		move(curr);
	}

	if (not lit[curr]) {
		if (curr == 1) {
			int next = children[curr][0];
			move(next);
			move(curr);
			move(next);
		} else {
			move(parent[curr]);
			move(curr);
		}
	}
}

int main() {
	cin >> n >> m;
	lit.resize(1 + n);
	for (int i = 1; i <= n; ++i) {
		cin >> lit[i];
	}
	adj.resize(1 + n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		adj[u].push_back(v);
		adj[v].push_back(u);
	}

	visited.resize(1 + n);
	parent.resize(1 + n);
	children.resize(1 + n);
	dfs1(1, 0);

	dfs2(1);

	cout << answer.size() << '\n';
	for (int a : answer) {
		cout << a << ' ';
	}
	cout << '\n';
}
