import sys
sys.setrecursionlimit(100_050)

# input

n, m = (int(x) for x in input().split())

lit = [int(x) for x in input().split()] # is room currently lit?

adj = [[] for _ in range(n)] # list of adjacent rooms
for _ in range(m):
    u, v = (int(x) - 1 for x in input().split())
    adj[u].append(v)
    adj[v].append(u)

# dfs traversal tree

visited = [False for _ in range(n)]
parent = [-1 for _ in range(n)]
children = [[] for _ in range(n)]

def dfs1(curr, prev):
    visited[curr] = True
    for next in adj[curr]:
        if next == prev: continue
        if visited[next]: continue
        parent[next] = curr
        children[curr].append(next)
        dfs1(next, curr)

dfs1(0, -1)

# answer

answer = []


def move(curr):
	answer.append(1 + curr)
	lit[curr] = 1 - lit[curr]

def dfs2(curr):
    move(curr)

    for next in children[curr]:
        dfs2(next)
        move(curr)

    if not lit[curr]:
        if curr == 0:
            next = children[curr][0]
            move(next)
            move(curr)
            move(next)
        else:
            move(parent[curr])
            move(curr)
dfs2(0)

print(len(answer))
print(*answer)
